import ctypes 
from wrapper import MLOapi
import time
import math

__version__     = "1.0.0"
__author__      = "MultilaneInc-ATE <support@multilaneinc.com>"
__date__        = '2021-09-16'

MLO = MLOapi.MLO()

ip = "172.16.108.95"
serial_number = ctypes.c_uint64(0)
SerialNumberVersion = ctypes.c_int(0)
ushort_data = ctypes.c_ushort(0)
double_data = ctypes.c_double(0)

print("connect", MLO.mlo_Connect(ip))
print("board ID: ", MLO.mlo_ReadBoardID())
print("Read Serial Number : ", MLO.mlo_ReadSerialNumber(ctypes.pointer(serial_number),ctypes.pointer(SerialNumberVersion)))

print("serial_number:" ,end =" ")
for i in range(8):
    print(str(hex(serial_number.value>>i*8&0xff)[2:]),end = " ")

print("Read Firmware Revision : ", MLO.mlo_ReadFirmwareRevision())

print("Read Type From EEPROM ", MLO.mlo_ReadTypeFromEEPROM(ctypes.pointer(ushort_data)), "Type: ", MLOapi.MLOType(int(ushort_data.value)))


for i in range(3):
    print("TempRead " ,i," = ", MLO.mlo_TempRead(i))

for channel in range(4):
    print("Switch Select 2x2", MLO.mlo_SwitchSelect_2x2(channel,False))
    print("Read Switch Select 2x2 ",MLO.mlo_ReadSwitchSelect_2x2(channel, ctypes.pointer(ushort_data)), " result: ", ushort_data.value)

for channel in range(4):

    print("Switch Select MEMS 4x1", MLO.mlo_SwitchSelect_MEMS_4x1(0,channel))
    print("Read Switch Select MEMS 4x1 ", MLO.mlo_ReadSwitchSelect_MEMS_4x1(channel,ctypes.pointer(ushort_data))," result: " , ushort_data.value)


Attenuation = 3
for channel in range(4):
    print("Set VOA Attenuation ", MLO.mlo_SetVOAAttenuation(channel,Attenuation)) 
    print("Read VOA Attenuation ", MLO.mlo_ReadVOAAttenuation(channel,ctypes.pointer(double_data)) ," result: " , double_data.value)
    

    
for channel in range(4):
    print("Read Optical Power ", MLO.mlo_ReadOpticalPower(channel,ctypes.pointer(double_data)), " result: ", 10*math.log(double_data.value,10) if double_data.value>0 else  "-inf" ) 




print("disconnect", MLO.mlo_Disconnect())
